/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2013  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/*  
 * Tests for the Tempura interpreter.  
 *  Ben Moszkowski
 */

/*set(garbage_flag,true). 	garbage collect before each run-command */
/*set(echo_flag,true).		echo commands */

define message(Text) = {
    format("\n[%s]\n",Text)
}.

load "library".


message("Testing three simple Tempura programs.").
load "simple".
run linear_test(3).
run while_test(4).
run skip_test().

message("Testing tree summation program.").
load "sum-tree".
run(sum_test(sum_test4)).

message("Testing parallel tree summation program.").
load "par-sum-tree".
run(sum_test(sum_test4)).

message("Testing serial quicksort").
load "ser-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3).
set print_states = true.

message("Testing parallel quicksort").
load "par-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3). 
set print_states = true.

message("Testing fast parallel quicksort").
load "fast-par-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3).
set print_states = true.

message("Testing pulse program").
load "pulse".
run pulse_test().

message("Testing latch program").
load "latch".
run latch_test().

message("Testing multiplier").
load "mult".
run mult_test(4,9).

message("Testing simple bootstrapped interpreter").
load "boot".
run boot_test(boot_test2).

message("Testing projection").
load "proj".
run simple_proj_test(). 
run var_proj_test(). 

    
message("Simple test of pointers.").
load "pointers".
run pointer_test().

    
message("Test of a pair of simple processes using shared buffers.").
load "buffer-example".
run buffer_test().


message("Testing process package.").
load "processes".
run process_test(process_test4).
    
message("Testing stream_test program").
load "streams".
run stream_test([0,10,20,30,40]).
message("Testing stream_status_test program").
run stream_status_test([0,10,20,30,40]).

message("Testing stream lexer").
load "stream-lexer".
run lexer_test(lexer_test2).


run lexer_test(lexer_test4).

message("Testing stream parser").
load "stream-parser".
run parser_test(parser_test1).
run parser_test(parser_test4). 

message("Testing stream lexer-parser-evaluator").
load "stream-eval".
run sys_test(lexer_test4).

message("End of tests").
