/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2013  Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * abp.t --- alternating bit protocol
 *
 */

load "../library/tam".

/*define chanbehD =    [0,1,0,0,1,0,1,1,1,1,1,1].*/
define chanbehD =    [1,0,0,1,1,1,1,1,1,1,1,1].
/*define chanbehAck =  [1,0,1,1,1,1,0,0,1,1,1,1].*/
define chanbehAck =  [1,0,0,0,1,1,1,1,1,1,1,1].
/* run */ define abp() = {

  exists D, Ack, Cs, Sendbuff, Data, I, Cn, Cr, Ind : {
   chan(D) and chan(Ack) and

define produce() = {
   Cs := (Cs + 1) mod 2 and
   Data := Data + 1 and
   Sendbuff:= Data
 }
  and
define sendD() = {
   format("sending   over D  %t\n", [Sendbuff, Cs]) and
   if chanbehD[Ind] = 1 then {
     wrc(D,[Sendbuff, Cs])
   } else {
     wrc(D,[-1,-1])
   }
 }
  and
define recack() = {
   rdc(Ack,Cn) and
   if Cn ~=-1 then {
     format("receiving over Ack %t\n",Cn) and
     if Sendbuff ~= -1 and Cs = Cn then {
        Sendbuff := -1 and
        format("Ack is ok\n")
     }
      else {
        Sendbuff := Sendbuff and
        format("Ack is not ok, resending\n")
      }
   } else {
     Sendbuff := Sendbuff and
        format("Ack is lost, resending\n")
     }
 }
  and
define recD() = {
   rdc(D,I) and
   if I[1] ~= -1 then {
     format("receiving over D  %t\n",I) and
     if Cr = I[1] then { 
       if chanbehAck[Ind]=1 then {
         wrc(Ack, Cr) 
       } else {
         wrc(Ack,-1)
       } and Cr:=(Cr + 1) mod 2 and
       format("Data over D is ok\n") and
       format("consume                           %t\n", I[0]) and
       format("sending   over Ack %t\n",Cr)
     }
      else {
       if chanbehAck[Ind]=1 then {
               wrc(Ack,(Cr-1)mod 2)
       } else {
         wrc(Ack,-1)
       } and Cr:=Cr and
       format("Data over D is not ok\n") and
       format("sending   over Ack %t\n",(Cr-1)mod 2)
      }
    } else {
       if chanbehAck[Ind]=1 then {
               wrc(Ack,(Cr-1)mod 2)
       } else {
          wrc(Ack,-1)
       } and Cr:=Cr and
       format("Data over D is lost\n") and
       format("sending   over Ack %t\n",(Cr-1)mod 2)
      }
    
 }
 and  Cs = 0 and Sendbuff = -1 and Cr = 1 and  Data = 0 and
   Ind = 0 and always { output Cs and output Cr } and
 format("Channel behavior D   %t\n",chanbehD) and
 format("Channel behavior Ack %t\n",chanbehAck) and
 while Ind < |chanbehD| do {
    skip and  
   if Sendbuff ~= -1 then {
    Ind:=Ind+1 and
    sendD() and
    recD() and
    recack() and
    stable(Cs) and
    stable(Data)
   }
    else {
     format("produce                           %t\n", Data) and
     stable(Cr) and
     stable(Ind) and
     produce()
   }
 }
 }
}.

